# stview.tcl --
#
# Copyright (c) 1996-1997 Daniel M. Wu
#
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.

proc stView {w} {
    browser $w
    brSetupOutlineLevel $w 0 stOpenFile stHelp 10
}

proc stExpandHdr {w cur file} {
    global pattern content options
    if {!$options(case)} {
	set switches -nocase
    }
    if {$options(regexp)} {
	lappend switches -regexp
    }
    lappend switches --
    brExpandHeading $w 0 $cur $content([glob $file]) $file    
    eval brHighlightText $w $file \{$pattern\} $switches
}

proc stContractHdr {w cur file} {
    brContractHeading $w $cur $file
}

proc stOpenFile {w filename line} {
    global cwd options
    set line [split $line :]
    set lineno [lindex $line 0]
    if {$options(editor) == "emacs"} {
	if [gnuExec "(progn (find-file-other-window \"$cwd/$filename\") \
                            (goto-line $lineno))"] {
	    printStatus .status "Gnu server not active"
	    return
	}
    } else {
	set cmdcode [exec xterm -e vi +[string trim $lineno] $filename &]
    }
    printStatus .status "File $filename loaded"
}

proc stHelp {w} {
    printStatus .status "Press Button-2 to view selected text"
}
